models/Comics.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "comics".
 *
 * @property int $codigo_numerico
 * @property string|null $nombre
 * @property string|null $coleccion
 * @property int|null $n_dibujante
 * @property string|null $nombre_dibujante
 * @property int|null $codigo_editorial
 * @property string|null $portada
 * @property string|null $descripción
 * @property int|null $valoracion
 *
 * @property Editoriales $codigoEditorial
 * @property Dibujan[] $dibujans
 * @property Dibujantes[] $codigoDibujantes
 * @property Lee[] $lees
 * @property Usuarios[] $codigoUsuarios
 * @property Vende[] $vendes
 */
class Comics extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'comics';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['codigo_editorial', 'valoracion'], 'integer'],
            [['nombre', 'coleccion'], 'string', 'max' => 100],
            [['nombre_dibujante'], 'string', 'max' => 50],
            [['portada'], 'string', 'max' => 1000],
            [['descripción'], 'string', 'max' => 10000],
            [['codigo_editorial'], 'exist', 'skipOnError' => true, 'targetClass' => Editoriales::className(), 'targetAttribute' => ['codigo_editorial' => 'codigo']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'codigo_numerico' => 'Codigo Numerico',
            'nombre' => 'Nombre',
            'coleccion' => 'Coleccion',
            'nombre_dibujante' => 'Nombre Dibujante',
            'codigo_editorial' => 'Codigo Editorial',
            'portada' => 'Portada',
            'descripción' => 'Descripción',
            'valoracion' => 'Valoracion',
        ];
    }

    /**
     * Gets query for [[CodigoEditorial]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCodigoEditorial()
    {
        return $this->hasOne(Editoriales::className(), ['codigo' => 'codigo_editorial']);
    }

    /**
     * Gets query for [[Dibujans]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDibujans()
    {
        return $this->hasMany(Dibujan::className(), ['codigo_numerico_comic' => 'codigo_numerico']);
    }

    /**
     * Gets query for [[CodigoDibujantes]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCodigoDibujantes()
    {
        return $this->hasMany(Dibujantes::className(), ['codigo' => 'codigo_dibujante'])->viaTable('dibujan', ['codigo_numerico_comic' => 'codigo_numerico']);
    }

    /**
     * Gets query for [[Lees]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getLees()
    {
        return $this->hasMany(Lee::className(), ['codigo_numerico_comic' => 'codigo_numerico']);
    }

    /**
     * Gets query for [[CodigoUsuarios]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCodigoUsuarios()
    {
        return $this->hasMany(Usuarios::className(), ['codigo' => 'codigo_usuario'])->viaTable('lee', ['codigo_numerico_comic' => 'codigo_numerico']);
    }

    /**
     * Gets query for [[Vendes]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getVendes()
    {
        return $this->hasMany(Vende::className(), ['codigo_numerico_comic' => 'codigo_numerico']);
    }
}

controllers/ComicsController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Comics;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * ComicsController implements the CRUD actions for Comics model.
 */
class ComicsController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Comics models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Comics::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Comics model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Comics model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Comics();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['lee/create', 'id' => $model->codigo_numerico]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Comics model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['comics/mostrarcomics', 'id' => $model->codigo_numerico]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Comics model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['comics/mostrarcomics']);
    }

    /**
     * Finds the Comics model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Comics the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Comics::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    public function actionMostrarcomics(){                //esta acción recibe como parámetro los comics y los muestra
        $dataProvider=new ActiveDataProvider([
            'query'=>Comics::find(),                      //con esta consulta hacemos que nos muestre todos los comics
            'pagination'=>[                               //determino la paginación
                'pageSize'=>5,                            //marco el tamaño de la paginación
                ]
           
                ]);
                return $this->render('comics',[           //renderizo en en el archivo php "comics"
                    
                    'dataProvider'=>$dataProvider,
            ]);
    }
}

controllers/LeeController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Lee;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LeeController implements the CRUD actions for Lee model.
 */
class LeeController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Lee models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Lee::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Lee model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Lee model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Lee();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Lee model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Lee model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Lee model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Lee the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Lee::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/comics/_comics.php
<?php

use yii\helpers\Html;
use yii\helpers\ArrayHelper;
use kartik\rating\StarRating;
use kartik\switchinput\SwitchInput;
use yii\widgets\ActiveForm;
use app\models\Lee;
$this->title = "Comics";    //ponemos el titulo que aparece en el head
                                                                 //pongo el Html::img, forma parte de bootstrap con lo que puedo implementar una imagen donde que quiera
?>
                                                                 
<div class="caja">
    <div class="col-md-12">
        <!--        con col-md modulamos en que tipo de formato lo queremos-->
        <div class="thumbnail">
           <?=Html::img($model->portada) ?>                                 
            <div class="caption">
                <h2 class="nombreComic"><?= $model->nombre?>: <?= $model->coleccion?></h2>
                <h3 class="nombreDib"><?= $model->nombre_dibujante?></h3>
<!--  pongo el dato procedente del modelo al que procede en este caso al de los comics    -->
                <p class="descComic"><?= $model->descripción ?> </p>
                
                
                <?php $form = ActiveForm::begin(); ?>
                
                <p class="StarRating">
                     <?=
                    StarRating::widget([
    'name' => 'rating_35',
    'value' =>$model->valoracion ,
    'pluginOptions' => ['displayOnly' => true,
        'filledStar' => '&#x2605;',
        'emptyStar' => '&#x2606;']
]);
                    ?>
                    
     
                </p>

                <?php ActiveForm::end(); ?>
                  
                     <?= Html::a('Actualizar', ['comics/update', 'id' => $model->codigo_numerico], ['class' => 'btn btn-primary']) ?>   
                     <?= Html::a('Eliminar', ['comics/delete', 'id' => $model->codigo_numerico], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => '¿Estás seguro de querer borrar este elemento?',
                'method' => 'post',
            ],                   //en los botones de actualizar eliminar ponemos "comics/update" y "comics/delete" para enlazarlos con los archivos php que realizan estas acciones, eso si en las views correspondientes
                                //al ser comics necesita la id con la que se identifica, en este caso código_numérico
                         ]) ?> 
                    <?= Html::a('Leído/Favorito', ['lee/view', 'id' => $model->codigo_numerico], ['class' => 'btn btn-info']) ?> 
                </div>               
            </div>
        </div>
    </div>
</div>

views/comics/_form.php
<?php

use yii\helpers\Html;
use kartik\form\ActiveForm;
use kartik\builder\Form;
use kartik\rating\StarRating;
use kartik\switchinput\SwitchInput;

/* @var $this yii\web\View */
/* @var $model app\models\Comics */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="comics-form">

    <?php $form = ActiveForm::begin(); ?>
    <?=
    Form::widget([// fields with labels
        'model' => $model,
        'form' => $form,
        'columns' => 2,
        'attributes' => [
            'nombre' => ['label' => 'Título del comic', 'options' => ['placeholder' => 'Introduce título del comic']],
            'nombre_dibujante' => ['label' => 'Nombre del dibujante', 'options' => ['placeholder' => 'Introduce el nombre del dibujante']],
        ]
    ])
    ?>
    <?=
    Form::widget([// fields with labels
        'model' => $model,
        'form' => $form,
        'columns' => 2,
        'attributes' => [
            'coleccion' => ['label' => 'Colección', 'options' => ['placeholder' => 'Introduce la colección a la que pertenece el comic']],
            'codigo_editorial' => ['label' => 'Código de la editorial', 'options' => ['placeholder' => 'Introduce el código de la editorial: Marvel->1, DC->2, Image Comics->4']],
        ]
    ])
    ?>
    <?=
    Form::widget([// fields with labels
        'model' => $model,
        'form' => $form,
        'columns' => 1,
        'attributes' => [
            'portada' => ['label' => 'Portada del comic', 'options' => ['placeholder' => 'Introduce la portada del comic,ejemplo:@carpeta/carpeta/foto.jpg']],
        ]
    ])
    ?>
    <?=
    Form::widget([// fields with labels
        'model' => $model,
        'form' => $form,
        'columns' => 1,
        'attributes' => [
            'descripción' => ['label' => 'Descripción del comic', 'options' => ['placeholder' => 'Introduce la sinopsis del comic']],
        ]
    ])
    ?>

    <?=
    $form->field($model, 'valoracion')->widget(StarRating::classname(), [
        'pluginOptions' => ['step' => 1,
            'filledStar' => '&#x2605;',
            'emptyStar' => '&#x2606;',
        ]
    ]);
    ?>


    <div class="form-group">
         <?= Html::resetButton('Restablecer', ['class' => 'btn btn-light']) ?>
        
        
        <?= Html::submitButton('Guardar', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/comics/comics.php
<?php

use yii\helpers\Html;
use yii\helpers\HtmlPurifier;
use yii\widgets\ListView;
$titulo="COMICS";   //ponemos el titulo que aparece en el head
?>


<h2 style="text-align: center; max-height: 50px;"><?= $titulo ?></h2>
<div class="linea_recta"></div>
<div class="texto_titulo">En esta sección podreís visualizar todos los comics disponibles a valorar, también teneis la opción de incluir vuestras propias sugerencias incluyendo el comic que querais, para compartirlo con el resto de usuarios.</div>
<p>
    
    <?=Html::a('Introducir nuevo comic',['comics/create'],['class' => 'btn btn-warning'])?>
</p>


<div class="row">                                         
    <?= ListView::widget([            //con esta parte de código cambiamos la vista de un Grid View a un ListView
       'dataProvider' => $dataProvider,
        'itemView'=>'_comics',         // vinculamos este archivo php con otro
        'layout'=>"{pager}\n{items}",
        
        
        
    ]);
   ?>   
    
</div>

views/comics/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Comics */

$this->title = 'Introduce un nuevo comic';

?>
<div class="comics-create">

    <h2><?= Html::encode($this->title) ?></h2>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/comics/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Comics';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="comics-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Comics', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigo_numerico',
            'nombre',
            'coleccion',
            'n_dibujante',
            'nombre_dibujante',
            //'codigo_editorial',
            //'portada',
            //'descripción',
            //'valoracion',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/comics/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Comics */

$this->title = 'Update Comics: ' . $model->nombre;

?>
<div class="comics-update">

    <h2><?= Html::encode($this->title) ?></h2>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/comics/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Comics */

$this->title = $model->codigo_numerico;
$this->params['breadcrumbs'][] = ['label' => 'Comics', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="comics-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->codigo_numerico], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->codigo_numerico], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'codigo_numerico',
            'nombre',
            'coleccion',
            'n_dibujante',
            'nombre_dibujante',
            'codigo_editorial',
            'portada',
            'descripción',
            'valoracion',
        ],
    ]) ?>

</div>